package cap6.biblio;

public class Biblioteca { 

  private Libro[] lib;
  private int numLibri;
  
  public Biblioteca(int n) { 
    lib = new Libro[n];
  }
  
  public boolean aggiungiLibro(Libro l) { 
	if (numLibri < lib.length) { 
	  lib[numLibri++] = l;
      return true;
    }
    else
      return false;
  }
  
  public Libro[] cercaPerAutore(Autore a) { 
    int n = 0;
    for (int i = 0; i < numLibri; i++)
      if (lib[i].getAutore().uguale(a))
        n++;
    if (n == 0)
      return null;
    Libro[] risul = new Libro[n];
    n = 0;
    for (int i = 0; i < numLibri; i++)
      if (lib[i].getAutore().uguale(a))
        risul[n++] = lib[i];
    return risul;
  }
  
  public Libro[] cercaPerCognome(String c) { 
    return cercaPerAutore(new Autore(null, c));
  }
  
  public Libro[] elenco() { 
    return cercaPerAutore(new Autore(null, null));
  }
  
  public Libro[] cercaRecenti(Data d) { 
    int n = 0;
    for (int i = 0; i < numLibri; i++)
      if (lib[i].getDataPub().confronta(d) >= 0)
        n++;
    if (n == 0)
      return null;
    Libro[] risul = new Libro[n];
    n = 0;
    for (int i = 0; i < numLibri; i++)
      if (lib[i].getDataPub().confronta(d) >= 0)
        risul[n++] = lib[i];
    return risul;
  }
  public boolean elimina(String t) { 
    for (int i = 0; i < numLibri; i++)
      if (lib[i].getTitolo().equals(t))
      { lib[i] = lib[--numLibri];
        lib[numLibri] = null;
        return true;
      }
    return false;
  }
}
